package com.yixin.ms.boot.uitls;

import cn.hutool.core.util.ObjectUtil;
import com.yixin.ms.boot.restful.RestCode;
import com.yixin.ms.boot.restful.RestDTO;
import com.yixin.ms.boot.restful.ServiceException;

import javax.sql.rowset.serial.SerialException;

/**
 * @description:
 * @ClassName ClassUtil
 * @Author WXG
 * @Date 2023/5/18 17:18
 */
public class ClassUtil {

    public static <T> void searchInit(RestDTO<T> restDTO, Class<T> tClass){
        if(!ObjectUtil.isNull(restDTO.getData())){
            return;
        }
        try {
            T t = tClass.newInstance();
            restDTO.setData(t);
        } catch (InstantiationException e) {
            throw new RuntimeException(e);
        } catch (IllegalAccessException e) {
            throw new RuntimeException(e);
        }
    }

    public static void checkData(Object o){
        if(ObjectUtil.isNull(o)){
            throw new ServiceException(RestCode.NOT_FOUND);
        }
    }
    public static void checkData(Object o,String throwString){
        if(ObjectUtil.isNull(o)){
            throw new ServiceException(throwString);
        }
    }
    public static void throwBusinessException(Boolean o,String throwString){
        if(o){
            throw new ServiceException(throwString);
        }
    }
    public static void throwBusinessException(Boolean o,RestCode restCode){
        if(o){
            throw new ServiceException(restCode);
        }
    }
    public static void throwBusinessException(Boolean o,RestCode restCode,String msg){
        if(o){
            throw new ServiceException(restCode.getCode(),msg);
        }
    }
}
